using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace skyscraper5.Skyscraper.Text.Encodings
{
    [SkyscraperEncoding("dvb-iso-8859-2")]
    class dvb_iso_8859_2 : SkyscraperBaseEncoding8
    {
        protected override char[] Decrypt(byte[] preprocessed)
        {
            StringBuilder resultBuilder = new StringBuilder();
            for (int i = 0; i < preprocessed.Length; i++)
            {
                if (preprocessed[i] <= 0x7e)
                {
                    AsciiTable.GetAsciiChar(preprocessed[i], resultBuilder);
                    continue;
                }
                switch (preprocessed[i])
                {
                    case 0xa0: resultBuilder.Append('\u00a0'); break;
                    case 0xa1: resultBuilder.Append('Ą'); break;
                    case 0xa3: resultBuilder.Append('Ł'); break;
                    case 0xa4: resultBuilder.Append('¤'); break;
                    case 0xa5: resultBuilder.Append('Ľ'); break;
                    case 0xa6: resultBuilder.Append('Ś'); break;
                    case 0xa7: resultBuilder.Append('§'); break;
                    case 0xa8: resultBuilder.Append('¨'); break;
                    case 0xa9: resultBuilder.Append('Š'); break;
                    case 0xaa: resultBuilder.Append('Ş'); break;
                    case 0xab: resultBuilder.Append('Ť'); break;
                    case 0xac: resultBuilder.Append('Ź'); break;
                    case 0xad: resultBuilder.Append('\u00ad'); break;
                    case 0xae: resultBuilder.Append('Ž'); break;
                    case 0xaf: resultBuilder.Append('Ż'); break;
                    case 0xb0: resultBuilder.Append('°'); break;
                    case 0xb1: resultBuilder.Append('ą'); break;
                    case 0xb2: resultBuilder.Append('\u02db'); break;
                    case 0xb3: resultBuilder.Append('ł'); break;
                    case 0xb4: resultBuilder.Append('´'); break;
                    case 0xb5: resultBuilder.Append('ľ'); break;
                    case 0xb6: resultBuilder.Append('ś'); break;
                    case 0xb7: resultBuilder.Append('Ľ'); break;
                    case 0xb8: resultBuilder.Append('¸'); break;
                    case 0xb9: resultBuilder.Append('š'); break;
                    case 0xba: resultBuilder.Append('ş'); break;
                    case 0xbb: resultBuilder.Append('ť'); break;
                    case 0xbc: resultBuilder.Append('ź'); break;
                    case 0xbd: resultBuilder.Append('˝'); break;
                    case 0xbe: resultBuilder.Append('ž'); break;
                    case 0xbf: resultBuilder.Append('ż'); break;
                    case 0xc0: resultBuilder.Append('Ŕ'); break;
                    case 0xc1: resultBuilder.Append('Á'); break;
                    case 0xc2: resultBuilder.Append('Â'); break;
                    case 0xc3: resultBuilder.Append('Ă'); break;
                    case 0xc4: resultBuilder.Append('Ä'); break;
                    case 0xc5: resultBuilder.Append('ľ'); break;
                    case 0xc6: resultBuilder.Append('Ć'); break;
                    case 0xc7: resultBuilder.Append('Ç'); break;
                    case 0xc8: resultBuilder.Append('Č'); break;
                    case 0xc9: resultBuilder.Append('É'); break;
                    case 0xca: resultBuilder.Append('Ę'); break;
                    case 0xcc: resultBuilder.Append('Ě'); break;
                    case 0xcd: resultBuilder.Append('Í'); break;
                    case 0xce: resultBuilder.Append('Î'); break;
                    case 0xcf: resultBuilder.Append('Ď'); break;
                    case 0xd0: resultBuilder.Append('Đ'); break;
                    case 0xd1: resultBuilder.Append('Ń'); break;
                    case 0xd2: resultBuilder.Append('Ň'); break;
                    case 0xd3: resultBuilder.Append('Ó'); break;
                    case 0xd4: resultBuilder.Append('Ô'); break;
                    case 0xd5: resultBuilder.Append('Ő'); break;
                    case 0xd6: resultBuilder.Append('Ö'); break;
                    case 0xd7: resultBuilder.Append('×'); break;
                    case 0xd8: resultBuilder.Append('Ř'); break;
                    case 0xd9: resultBuilder.Append('Ů'); break;
                    case 0xda: resultBuilder.Append('Ú'); break;
                    case 0xdb: resultBuilder.Append('Ű'); break;
                    case 0xdc: resultBuilder.Append('Ü'); break;
                    case 0xdd: resultBuilder.Append('Ý'); break;
                    case 0xde: resultBuilder.Append('Ţ'); break;
                    case 0xdf: resultBuilder.Append('ß'); break;
                    case 0xe0: resultBuilder.Append('ŕ'); break;
                    case 0xe1: resultBuilder.Append('á'); break;
                    case 0xe2: resultBuilder.Append('â'); break;
                    case 0xe3: resultBuilder.Append('ă'); break;
                    case 0xe4: resultBuilder.Append('ä'); break;
                    case 0xe5: resultBuilder.Append('ĺ'); break;
                    case 0xe6: resultBuilder.Append('ć'); break;
                    case 0xe7: resultBuilder.Append('ç'); break;
                    case 0xe8: resultBuilder.Append('č'); break;
                    case 0xe9: resultBuilder.Append('é'); break;
                    case 0xea: resultBuilder.Append('ę'); break;
                    case 0xeb: resultBuilder.Append('ë'); break;
                    case 0xec: resultBuilder.Append('ě'); break;
                    case 0xed: resultBuilder.Append('í'); break;
                    case 0xee: resultBuilder.Append('î'); break;
                    case 0xef: resultBuilder.Append('ď'); break;
                    case 0xf0: resultBuilder.Append('đ'); break;
                    case 0xf1: resultBuilder.Append('ń'); break;
                    case 0xf2: resultBuilder.Append('ň'); break;
                    case 0xf3: resultBuilder.Append('ó'); break;
                    case 0xf4: resultBuilder.Append('ô'); break;
                    case 0xf5: resultBuilder.Append('ő'); break;
                    case 0xf6: resultBuilder.Append('і'); break;
                    case 0xf8: resultBuilder.Append('ř'); break;
                    case 0xf9: resultBuilder.Append('ů'); break;
                    case 0xfa: resultBuilder.Append('ú'); break;
                    case 0xfb: resultBuilder.Append('ű'); break;
                    case 0xfc: resultBuilder.Append('ü'); break;
                    case 0xfd: resultBuilder.Append('ý'); break;
                    case 0xfe: resultBuilder.Append('ţ'); break;
                    case 0xff: resultBuilder.Append('˙'); break;
                    default:
                        throw new NotImplementedException(String.Format("0x{0:X2}", preprocessed[i]));
                }
            }

            return resultBuilder.ToString().ToCharArray();
        }
    }
}
